~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

TOMOYO Linux Cross Reference
Linux/tools/perf/tests/shell/lock_contention.sh

Version: ~ [ linux-6.12-rc7 ] ~ [ linux-6.11.7 ] ~ [ linux-6.10.14 ] ~ [ linux-6.9.12 ] ~ [ linux-6.8.12 ] ~ [ linux-6.7.12 ] ~ [ linux-6.6.60 ] ~ [ linux-6.5.13 ] ~ [ linux-6.4.16 ] ~ [ linux-6.3.13 ] ~ [ linux-6.2.16 ] ~ [ linux-6.1.116 ] ~ [ linux-6.0.19 ] ~ [ linux-5.19.17 ] ~ [ linux-5.18.19 ] ~ [ linux-5.17.15 ] ~ [ linux-5.16.20 ] ~ [ linux-5.15.171 ] ~ [ linux-5.14.21 ] ~ [ linux-5.13.19 ] ~ [ linux-5.12.19 ] ~ [ linux-5.11.22 ] ~ [ linux-5.10.229 ] ~ [ linux-5.9.16 ] ~ [ linux-5.8.18 ] ~ [ linux-5.7.19 ] ~ [ linux-5.6.19 ] ~ [ linux-5.5.19 ] ~ [ linux-5.4.285 ] ~ [ linux-5.3.18 ] ~ [ linux-5.2.21 ] ~ [ linux-5.1.21 ] ~ [ linux-5.0.21 ] ~ [ linux-4.20.17 ] ~ [ linux-4.19.323 ] ~ [ linux-4.18.20 ] ~ [ linux-4.17.19 ] ~ [ linux-4.16.18 ] ~ [ linux-4.15.18 ] ~ [ linux-4.14.336 ] ~ [ linux-4.13.16 ] ~ [ linux-4.12.14 ] ~ [ linux-4.11.12 ] ~ [ linux-4.10.17 ] ~ [ linux-4.9.337 ] ~ [ linux-4.4.302 ] ~ [ linux-3.10.108 ] ~ [ linux-2.6.32.71 ] ~ [ linux-2.6.0 ] ~ [ linux-2.4.37.11 ] ~ [ unix-v6-master ] ~ [ ccs-tools-1.8.12 ] ~ [ policy-sample ] ~
Architecture: ~ [ i386 ] ~ [ alpha ] ~ [ m68k ] ~ [ mips ] ~ [ ppc ] ~ [ sparc ] ~ [ sparc64 ] ~

  1 #!/bin/sh
  2 # kernel lock contention analysis test
  3 # SPDX-License-Identifier: GPL-2.0
  4 
  5 set -e
  6 
  7 err=0
  8 perfdata=$(mktemp /tmp/__perf_test.perf.data.XXXXX)
  9 result=$(mktemp /tmp/__perf_test.result.XXXXX)
 10 
 11 cleanup() {
 12         rm -f ${perfdata}
 13         rm -f ${result}
 14         trap - EXIT TERM INT
 15 }
 16 
 17 trap_cleanup() {
 18         cleanup
 19         exit ${err}
 20 }
 21 trap trap_cleanup EXIT TERM INT
 22 
 23 check() {
 24         if [ "$(id -u)" != 0 ]; then
 25                 echo "[Skip] No root permission"
 26                 err=2
 27                 exit
 28         fi
 29 
 30         if ! perf list | grep -q lock:contention_begin; then
 31                 echo "[Skip] No lock contention tracepoints"
 32                 err=2
 33                 exit
 34         fi
 35 
 36         # shellcheck disable=SC2046
 37         if [ `nproc` -lt 4 ]; then
 38                 echo "[Skip] Low number of CPUs (`nproc`), lock event cannot be triggered certainly"
 39                 err=2
 40                 exit
 41         fi
 42 }
 43 
 44 test_record()
 45 {
 46         echo "Testing perf lock record and perf lock contention"
 47         perf lock record -o ${perfdata} -- perf bench sched messaging > /dev/null 2>&1
 48         # the output goes to the stderr and we expect only 1 output (-E 1)
 49         perf lock contention -i ${perfdata} -E 1 -q 2> ${result}
 50         if [ "$(cat "${result}" | wc -l)" != "1" ]; then
 51                 echo "[Fail] Recorded result count is not 1:" "$(cat "${result}" | wc -l)"
 52                 err=1
 53                 exit
 54         fi
 55 }
 56 
 57 test_bpf()
 58 {
 59         echo "Testing perf lock contention --use-bpf"
 60 
 61         if ! perf lock con -b true > /dev/null 2>&1 ; then
 62                 echo "[Skip] No BPF support"
 63                 return
 64         fi
 65 
 66         # the perf lock contention output goes to the stderr
 67         perf lock con -a -b -E 1 -q -- perf bench sched messaging > /dev/null 2> ${result}
 68         if [ "$(cat "${result}" | wc -l)" != "1" ]; then
 69                 echo "[Fail] BPF result count is not 1:" "$(cat "${result}" | wc -l)"
 70                 err=1
 71                 exit
 72         fi
 73 }
 74 
 75 test_record_concurrent()
 76 {
 77         echo "Testing perf lock record and perf lock contention at the same time"
 78         perf lock record -o- -- perf bench sched messaging 2> /dev/null | \
 79         perf lock contention -i- -E 1 -q 2> ${result}
 80         if [ "$(cat "${result}" | wc -l)" != "1" ]; then
 81                 echo "[Fail] Recorded result count is not 1:" "$(cat "${result}" | wc -l)"
 82                 err=1
 83                 exit
 84         fi
 85 }
 86 
 87 test_aggr_task()
 88 {
 89         echo "Testing perf lock contention --threads"
 90         perf lock contention -i ${perfdata} -t -E 1 -q 2> ${result}
 91         if [ "$(cat "${result}" | wc -l)" != "1" ]; then
 92                 echo "[Fail] Recorded result count is not 1:" "$(cat "${result}" | wc -l)"
 93                 err=1
 94                 exit
 95         fi
 96 
 97         if ! perf lock con -b true > /dev/null 2>&1 ; then
 98                 return
 99         fi
100 
101         # the perf lock contention output goes to the stderr
102         perf lock con -a -b -t -E 1 -q -- perf bench sched messaging > /dev/null 2> ${result}
103         if [ "$(cat "${result}" | wc -l)" != "1" ]; then
104                 echo "[Fail] BPF result count is not 1:" "$(cat "${result}" | wc -l)"
105                 err=1
106                 exit
107         fi
108 }
109 
110 test_aggr_addr()
111 {
112         echo "Testing perf lock contention --lock-addr"
113         perf lock contention -i ${perfdata} -l -E 1 -q 2> ${result}
114         if [ "$(cat "${result}" | wc -l)" != "1" ]; then
115                 echo "[Fail] Recorded result count is not 1:" "$(cat "${result}" | wc -l)"
116                 err=1
117                 exit
118         fi
119 
120         if ! perf lock con -b true > /dev/null 2>&1 ; then
121                 return
122         fi
123 
124         # the perf lock contention output goes to the stderr
125         perf lock con -a -b -l -E 1 -q -- perf bench sched messaging > /dev/null 2> ${result}
126         if [ "$(cat "${result}" | wc -l)" != "1" ]; then
127                 echo "[Fail] BPF result count is not 1:" "$(cat "${result}" | wc -l)"
128                 err=1
129                 exit
130         fi
131 }
132 
133 test_aggr_cgroup()
134 {
135         echo "Testing perf lock contention --lock-cgroup"
136 
137         if ! perf lock con -b true > /dev/null 2>&1 ; then
138                 echo "[Skip] No BPF support"
139                 return
140         fi
141 
142         # the perf lock contention output goes to the stderr
143         perf lock con -a -b -g -E 1 -q -- perf bench sched messaging > /dev/null 2> ${result}
144         if [ "$(cat "${result}" | wc -l)" != "1" ]; then
145                 echo "[Fail] BPF result count is not 1:" "$(cat "${result}" | wc -l)"
146                 err=1
147                 exit
148         fi
149 }
150 
151 test_type_filter()
152 {
153         echo "Testing perf lock contention --type-filter (w/ spinlock)"
154         perf lock contention -i ${perfdata} -Y spinlock -q 2> ${result}
155         if [ "$(grep -c -v spinlock "${result}")" != "0" ]; then
156                 echo "[Fail] Recorded result should not have non-spinlocks:" "$(cat "${result}")"
157                 err=1
158                 exit
159         fi
160 
161         if ! perf lock con -b true > /dev/null 2>&1 ; then
162                 return
163         fi
164 
165         perf lock con -a -b -Y spinlock -q -- perf bench sched messaging > /dev/null 2> ${result}
166         if [ "$(grep -c -v spinlock "${result}")" != "0" ]; then
167                 echo "[Fail] BPF result should not have non-spinlocks:" "$(cat "${result}")"
168                 err=1
169                 exit
170         fi
171 }
172 
173 test_lock_filter()
174 {
175         echo "Testing perf lock contention --lock-filter (w/ tasklist_lock)"
176         perf lock contention -i ${perfdata} -l -q 2> ${result}
177         if [ "$(grep -c tasklist_lock "${result}")" != "1" ]; then
178                 echo "[Skip] Could not find 'tasklist_lock'"
179                 return
180         fi
181 
182         perf lock contention -i ${perfdata} -L tasklist_lock -q 2> ${result}
183 
184         # find out the type of tasklist_lock
185         test_lock_filter_type=$(head -1 "${result}" | awk '{ print $8 }' | sed -e 's/:.*//')
186 
187         if [ "$(grep -c -v "${test_lock_filter_type}" "${result}")" != "0" ]; then
188                 echo "[Fail] Recorded result should not have non-${test_lock_filter_type} locks:" "$(cat "${result}")"
189                 err=1
190                 exit
191         fi
192 
193         if ! perf lock con -b true > /dev/null 2>&1 ; then
194                 return
195         fi
196 
197         perf lock con -a -b -L tasklist_lock -q -- perf bench sched messaging > /dev/null 2> ${result}
198         if [ "$(grep -c -v "${test_lock_filter_type}" "${result}")" != "0" ]; then
199                 echo "[Fail] BPF result should not have non-${test_lock_filter_type} locks:" "$(cat "${result}")"
200                 err=1
201                 exit
202         fi
203 }
204 
205 test_stack_filter()
206 {
207         echo "Testing perf lock contention --callstack-filter (w/ unix_stream)"
208         perf lock contention -i ${perfdata} -v -q 2> ${result}
209         if [ "$(grep -c unix_stream "${result}")" = "0" ]; then
210                 echo "[Skip] Could not find 'unix_stream'"
211                 return
212         fi
213 
214         perf lock contention -i ${perfdata} -E 1 -S unix_stream -q 2> ${result}
215         if [ "$(cat "${result}" | wc -l)" != "1" ]; then
216                 echo "[Fail] Recorded result should have a lock from unix_stream:" "$(cat "${result}")"
217                 err=1
218                 exit
219         fi
220 
221         if ! perf lock con -b true > /dev/null 2>&1 ; then
222                 return
223         fi
224 
225         perf lock con -a -b -S unix_stream -E 1 -q -- perf bench sched messaging > /dev/null 2> ${result}
226         if [ "$(cat "${result}" | wc -l)" != "1" ]; then
227                 echo "[Fail] BPF result should have a lock from unix_stream:" "$(cat "${result}")"
228                 err=1
229                 exit
230         fi
231 }
232 
233 test_aggr_task_stack_filter()
234 {
235         echo "Testing perf lock contention --callstack-filter with task aggregation"
236         perf lock contention -i ${perfdata} -v -q 2> ${result}
237         if [ "$(grep -c unix_stream "${result}")" = "0" ]; then
238                 echo "[Skip] Could not find 'unix_stream'"
239                 return
240         fi
241 
242         perf lock contention -i ${perfdata} -t -E 1 -S unix_stream -q 2> ${result}
243         if [ "$(cat "${result}" | wc -l)" != "1" ]; then
244                 echo "[Fail] Recorded result should have a task from unix_stream:" "$(cat "${result}")"
245                 err=1
246                 exit
247         fi
248 
249         if ! perf lock con -b true > /dev/null 2>&1 ; then
250                 return
251         fi
252 
253         perf lock con -a -b -t -S unix_stream -E 1 -q -- perf bench sched messaging > /dev/null 2> ${result}
254         if [ "$(cat "${result}" | wc -l)" != "1" ]; then
255                 echo "[Fail] BPF result should have a task from unix_stream:" "$(cat "${result}")"
256                 err=1
257                 exit
258         fi
259 }
260 test_cgroup_filter()
261 {
262         echo "Testing perf lock contention --cgroup-filter"
263 
264         if ! perf lock con -b true > /dev/null 2>&1 ; then
265                 echo "[Skip] No BPF support"
266                 return
267         fi
268 
269         perf lock con -a -b -g -E 1 -F wait_total -q -- perf bench sched messaging > /dev/null 2> ${result}
270         if [ "$(cat "${result}" | wc -l)" != "1" ]; then
271                 echo "[Fail] BPF result should have a cgroup result:" "$(cat "${result}")"
272                 err=1
273                 exit
274         fi
275 
276         cgroup=$(cat "${result}" | awk '{ print $3 }')
277         perf lock con -a -b -g -E 1 -G "${cgroup}" -q -- perf bench sched messaging > /dev/null 2> ${result}
278         if [ "$(cat "${result}" | wc -l)" != "1" ]; then
279                 echo "[Fail] BPF result should have a result with cgroup filter:" "$(cat "${cgroup}")"
280                 err=1
281                 exit
282         fi
283 }
284 
285 
286 test_csv_output()
287 {
288         echo "Testing perf lock contention CSV output"
289         perf lock contention -i ${perfdata} -E 1 -x , --output ${result}
290         # count the number of commas in the header
291         # it should have 5: contended, total-wait, max-wait, avg-wait, type, caller
292         header=$(grep "# output:" ${result} | tr -d -c , | wc -c)
293         if [ "${header}" != "5" ]; then
294                 echo "[Fail] Recorded result does not have enough output columns: ${header} != 5"
295                 err=1
296                 exit
297         fi
298         # count the number of commas in the output
299         output=$(grep -v "^#" ${result} | tr -d -c , | wc -c)
300         if [ "${header}" != "${output}" ]; then
301                 echo "[Fail] Recorded result does not match the number of commas: ${header} != ${output}"
302                 err=1
303                 exit
304         fi
305 
306         if ! perf lock con -b true > /dev/null 2>&1 ; then
307                 echo "[Skip] No BPF support"
308                 return
309         fi
310 
311         # the perf lock contention output goes to the stderr
312         perf lock con -a -b -E 1 -x , --output ${result} -- perf bench sched messaging > /dev/null 2>&1
313         output=$(grep -v "^#" ${result} | tr -d -c , | wc -c)
314         if [ "${header}" != "${output}" ]; then
315                 echo "[Fail] BPF result does not match the number of commas: ${header} != ${output}"
316                 err=1
317                 exit
318         fi
319 }
320 
321 check
322 
323 test_record
324 test_bpf
325 test_record_concurrent
326 test_aggr_task
327 test_aggr_addr
328 test_aggr_cgroup
329 test_type_filter
330 test_lock_filter
331 test_stack_filter
332 test_aggr_task_stack_filter
333 test_cgroup_filter
334 test_csv_output
335 
336 exit ${err}

~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

kernel.org | git.kernel.org | LWN.net | Project Home | SVN repository | Mail admin

Linux® is a registered trademark of Linus Torvalds in the United States and other countries.
TOMOYO® is a registered trademark of NTT DATA CORPORATION.

sflogo.php